//app.js
App({
  onLaunch: function () {
    // 展示本地存储能力
    var logs = wx.getStorageSync('logs') || []
    logs.unshift(Date.now())
    wx.setStorageSync('logs', logs)

    // 登录
    wx.login({
      success: res => {
        // 发送 res.code 到后台换取 openId, sessionKey, unionId
      }
    })
    // 获取用户信息
    wx.getSetting({
      success: res => {
        if (res.authSetting['scope.userInfo']) {
          // 已经授权，可以直接调用 getUserInfo 获取头像昵称，不会弹框
          wx.getUserInfo({
            success: res => {
              // 可以将 res 发送给后台解码出 unionId
              this.globalData.userInfo = res.userInfo

              // 由于 getUserInfo 是网络请求，可能会在 Page.onLoad 之后才返回
              // 所以此处加入 callback 以防止这种情况
              if (this.userInfoReadyCallback) {
                this.userInfoReadyCallback(res)
              }
            }
          })
        }
      }
    })
  },
  globalData: {
    userInfo: null,
    //一些默认值
    operate_btn_height: 80,
    recordTypes: {
      "diet_morning": '早餐',
      "diet_afternoon": "午餐",
      "diet_evening": "晚餐",
      "diet_morning_more": "上午加餐",
      "diet_afternoon_more": "下午加餐",
      "diet_water": "喝水",
      "diet_milk": "饮用牛奶",
      "sleep_time": "睡觉时间",
      "wc_pee": "小便",
      "wc_poo": "便",
      "wc_diaper": "换尿布"
    },
    eatStates: {
      "less": "少",
      "normal": "正常",
      "more": "多"
    },

  }
})